/*
    hash.h
    $Id: hash.h,v 1.1 2010/03/08 08:01:48 daichi Exp $

*/
#ifndef _HASH_H_
#define _HASH_H_

#ifndef MEMORY
  #include <google/dense_hash_map>
  using google::dense_hash_map;
  typedef dense_hash_map <int, void *> hashmap;
#else
  #include <google/sparse_hash_map>
  using google::sparse_hash_map;
  typedef sparse_hash_map <int, void *> hashmap;
#endif

typedef void (*nodefunc)(void *, void *);
typedef double (*foldfunc)(void *, void *);

void hash_foreach (hashmap *hash, nodefunc func, void *arg);
double hash_fold (hashmap *hash, foldfunc func, void *arg);

#endif
