/*
    record.cpp
    $Id: record.cpp,v 1.1 2010/03/08 08:01:39 daichi Exp $

*/
#include "hpylm.h"
#include "record.h"

using namespace std;

int pow2 (int n);

int
record::add (restaurant *word)
{
	v.push_back (word);
	return (v.size() - 1);
}

void
record::erase (restaurant *word)
{
	int i, cur = word->cur;

	v.erase (v.begin() + cur);
	for (i = cur; i < v.size(); i++)
	{
		v[i]->cur = i;
	}
}

void	
record::incr (restaurant *word)
{
	int cur = word->cur, count = word->ncounts;  /* after increment */
	int d, bound;

	if ((d = pow2(count)) > 0)
	{
		if (bounds.size() <= d)
		{
			bounds.push_back (0);
		}
		bound = bounds[d-1]++;
		if (bound < cur)
		{
			rswap (bound, cur);
		}
	} else {
		if (bounds.empty())
		{
			bounds.push_back (0);
		}
	}
}

void
record::decr (restaurant *word)
{
	int cur = word->cur, count = word->ncounts + 1;  /* before decrement */
	int d, bound;

	if ((d = pow2(count)) > 0)
	{
		bound = --bounds[d-1];
		if (cur < bound)
		{
			rswap (cur, bound);
		}
	}
}

void
record::rswap (int left, int right)
{
	swap (v[left], v[right]);
	v[right]->cur = right;
	v[left]->cur = left;
}

void
record::foreach (recfunc f, void *param)
{
	int t, i, st, ed, vs = v.size(), bs = bounds.size();
	int prune = 0;

	for (t = bs - 1; t >= 0 && bounds[t] < vs; t--)
	{
		st = bounds[t];
		ed = (t > 0) ? bounds[t - 1] : vs;

		for (i = st; i < ed; i++)
		{
			if ((*f)(v[i], param))	/* return 0 if success */
				prune = 1;
		}
		
		if (prune) break;
	}
}

void
record::print ()
{
	int i;
	
	for (i = 0; i < v.size(); i++)
	{
		printf("v[%d] = %d, ncounts = %d, cur = %d\n",
		       i, v[i]->word, v[i]->ncounts, v[i]->cur);
	}
	printf("bounds =");
	for (i = 0; i < bounds.size(); i++)
	{
		printf(" %d", bounds[i]);
	}
	printf("\n");
}

/* utility */

int
pow2 (int n)
{
	int i = 0, x = -n & n;

	if (!n) return -1;
	
	if (~x & n)
		return -1;
	else {
		while (x) { x >>= 1; ++i; }
		return --i;
	}
}

