/*
    splay.h
    $Id: splay.h,v 1.1 2010/03/08 08:01:56 daichi Exp $

*/
#ifndef __SPLAY_H__
#define __SPLAY_H__
#ifdef __cplusplus
extern "C" {
#endif	

typedef int (*cmpfunc)(void *, void *);
typedef void (*prfunc)(void *);
typedef void (*nodefunc)(void *, void *);
typedef double (*foldfunc)(void *, void *);
typedef int (*maxfunc)(void *, void *);
typedef struct splay splay;
struct splay {
	splay *left;
	splay *right;
	void *item;
};

splay *splay_insert (splay *t, void *i, cmpfunc comp);
splay *splay_delete (splay *t, void *i, cmpfunc comp);
splay *splay_free (splay *t);
void  *splay_find (splay **tp, void *i, cmpfunc comp);
void  *splay_lookup (splay *t, void *i, cmpfunc comp);
void splay_print (splay *t, prfunc print);
void splay_foreach (splay *t, nodefunc func, void *arg);
int  splay_max (splay *t, maxfunc func, void *arg);
int  splay_nodes (splay *t);
double splay_fold (splay *t, foldfunc func, void *arg);

#ifdef __cplusplus
}
#endif
#endif
